%% TU Delft iGEM 2009 team
%% Jacobian
%%
%% This file computes the Jacobian
%%
%%
%% August 10, 2009
%% Version 1.0

syms dy1 dy2 dy3 dy4 dy5 dy6 dy7 dy8 dy9 y1 y2 y3 y4 y5 y6 y7 y8 y9;
syms k1 k2 k3 k4 a1 a2 a3 a4 c1 c2 c3 c4 n1 n2 n3 n4 d1m d2m d3m d4m n_IPTG d1p d2p d3p d4p alp1 alp2 alp3 alp4 k_IPTG IPTG_ext LacI_total K50_IPTG k_IPTG_out;

% the system of ODEs

dy1 = k_IPTG*(IPTG_ext) - k_IPTG_out*y1; %IPTG internal

% transcription
dy2 = c1*(a1+(1-a1)*(1/(1+((LacI_total/(1+(y1/K50_IPTG)^n_IPTG))/k1)^n1))) - d1m*y2 ; %TetR mRNA
dy3 = c2*(a2+(1-a2)*(1/(1+(y6/k2)^n2))) - d2m*y3 ; %CI mRNA
dy4 = c3*(a3+(1-a3)*(1/(1+(y6/k3)^n3))) - d3m*y4 ; %RFP mRNA
dy5 = c4*(a4+(1-a4)*(1/(1+(y7/k4)^n4))) - d4m*y5 ; %GFP mRNA

% translation
dy6 = alp1*y2 - d1p*y6; %TetR
dy7 = alp2*y3 - d2p*y7; %CI
dy8 = alp3*y4 - d3p*y8; %RFP
dy9 = alp4*y5 - d4p*y9; %GFP

funkygg = [dy1;dy2;dy3;dy4;dy5;dy6;dy7;dy8;dy9];
paramvar = [y1, y2, y3, y4, y5, y6, y7, y8, y9];
ssvalues = [1 1 1 1 1 1 1 1 1];

% this is the jacobian
jacky = subs(jacobian(funkygg,paramvar),paramvar,ssvalues)

% these are its eigenvalues
eigjacky = eig(subs(jacobian(funkygg,paramvar),paramvar,ssvalues))
