%% TU Delft iGEM 2009 team
%% Cascade model ODEs
%%
%% This file contains the ODEs
%%
%% July 27, 2009
%% Version 1.2

function varargout = ode_bista(t,y,flag,param)

switch flag
    case ''
  
        
        k1 = param(1);%     k1 = K50_LacI;
        k2 = param(2);%     k2 = K50_TetR;
        k3 = param(3);%     k3 = K50_TetR;
        k4 = param(4);%     k4 = K50_Cl;
        % 
        a1 = param(5);%     a1 = a_pLac;
        a2 = param(6);%     a2 = a_pTet;
        a3 = param(7);%     a3 = a_pTet;
        a4 = param(8);%     a4 = a_plam;
        %     
        c1 = param(9);%     c1 = c_pLac;
        c2 = param(10);%     c2 = c_pTet;
        c3 = param(11);%     c3 = c_pTet;
        c4 = param(12);%     c4 = c_plam;
        %     
        n1 = param(13);%     n1 = n_pLac_LacI;
        n2 = param(14);%     n2 = n_pTet_TetR;
        n3 = param(15);%     n3 = n_pTet_TetR;
        n4 = param(16);%     n4 = n_plam_Cl;
        %     
        d1m = param(17);%     d1 = d_TetR;
        d2m = param(18);%     d2 = d_Cl;
        d3m = param(19);%     d3 = d_RFP;
        d4m = param(20);%     d4 = d_GFP;
        
        n_IPTG = param(21); %   LacI_un
        
        d1p = param(22);
        d2p = param(23);
        d3p = param(24);
        d4p = param(25);        
        
        alpha1 = param(26);
        alpha2 = param(27);
        alpha3 = param(28);
        alpha4 = param(29);
        
        k_IPTG = param(30);
        IPTG_ext = param(31);
        LacI_total = param(32);
        K50_IPTG = param(33);
        k_IPTG_out = param(34);
        
        dy(1) = k_IPTG*(IPTG_ext) - k_IPTG_out*y(1); %IPTG internal
        
        dy(2) = c1*(a1+(1-a1)*(1/(1+((LacI_total/(1+(y(1)/K50_IPTG)^n_IPTG))/k1)^n1))) - d1m*y(2) ; %TetR mRNA
        dy(3) = c2*(a2+(1-a2)*(1/(1+(y(6)/k2)^n2))) - d2m*y(3) ; %CI mRNA
        dy(4) = c3*(a3+(1-a3)*(1/(1+(y(6)/k3)^n3))) - d3m*y(4) ; %RFP mRNA
        dy(5) = c4*(a4+(1-a4)*(1/(1+(y(7)/k4)^n4))) - d4m*y(5) ; %GFP mRNA
        
        dy(6) = alpha1*y(2) - d1p*y(6); %TetR
        dy(7) = alpha2*y(3) - d2p*y(7); %CI
        dy(8) = alpha3*y(4) - d3p*y(8); %RFP
        dy(9) = alpha4*y(5) - d4p*y(9); %GFP
        
        varargout{1} = dy(:);
    
    case 'init'

        y0 = y;
    
    otherwise
        
        error(['Unknown flag ''' flag '''.']);

end


return


