%% TU Delft iGEM 2009 team
%% parameters
%%
%% parameter values should be changed here
%%
%% See:
%%
%% http://2009.igem.org/Team:TUDelft/Modeling_Parameters
%%
%% October 2, 2009
%% Version 2.0
%% 
    
    %% for values see http://parts.mit.edu/igem07/index.php?title=ETHZ/Parameters
    % http://openwetware.org/wiki/User:Johnsy/Lipoprotein_Modelling/De_Novo
    % _Cholesterol
    
    %% Units:
    %% all concentrations in M
    %% all transcription rates in M/min
    %% all dissociation constants in M
    %% all degradation rates in M/min
    %% all leakiness factors in %
    
    % Ecoli cell cytoplasm volume 6.7e-16 L
    % Number of molecules = C*Na*V = Concentration*403474000
    % 2 nM = 1 molecule in cell
    
    c_pLac = 5e-10; % maximum transcription rate (M/min) %
    c_pTet = 1.5e-7; % maximum transcription rate (M/min) %
    c_plam = 1.5e-7; % maximum transcription rate (M/min) %
    
    a_pLac = 0; % leakiness factor (a percentage of the maximum transcription rate) %
    a_pTet = 0; % leakiness factor (a percentage of the maximum transcription rate) %
    a_plam = 0; % leakiness factor (a percentage of the maximum transcription rate) %
    
    K50_IPTG = 1.3*10^(-6);  % dissociation constant (M) %
    K50_LacI = 800*10^(-9);  % dissociation constant (M) %
    K50_TetR = 179*10^(-12); % dissociation constant (M) %
    K50_CI   = 8*10^(-12);   % dissociation constant (M) %
    
    n_IPTG = 2; % Hills coefficient %
    n_LacI = 2; % Hills coefficient %
    n_TetR = 3; % Hills coefficient %
    n_CI   = 2; % Hills coefficient %

    d_LacI = 0.1386; % degradation rate %
    d_TetR = 0.1386; % degradation rate %
    d_CI   = 0.042;  % degradation rate % 0.042
    d_RFP  = 6.3e-3; % degradation rate %
    d_GFP  = 6.3e-3; % degradation rate %
    d_mRNA = 0.029; % 0.029
    
    mRNAconc = 5e-8;% 7.4e-10 to 5e-7
    % http://www3.interscience.wiley.com/cgi-bin/fulltext/72513418/HTMLSTAR
    % T
    % mRNA concentration estimates from 0.3 to over 200.0 transcripts per cell
    
    % http://jb.asm.org/cgi/content/full/182/11/3037/T2
    % 16 to 57 depending on growth rate
    alpha1 = 30; % translation rate translations/min/mRNA
    alpha2 = 30; % translation rate translations/min/mRNA
    alpha3 = 30; % translation rate translations/min/mRNA
    alpha4 = 30; % translation rate translations/min/mRNA
    
    
    LacI_total = 0.0067; % http://www.pubmedcentral.nih.gov/articlerender.fcgi?artid=85401 % 50*10^(-6); % total LacI concentration
    IPTG_in = 10*10^(-6); % IPTG concentration 
    IPTG_ext = 10*10^(-4); % IPTG concentration
    
    
    k_IPTG = 0.92; % rate constant (per min) from http://www.sciencedirect.com/science?_ob=ArticleURL&_udi=B94RW-4VGGB7R-D&_user=499885&_rdoc=1&_fmt=&_orig=search&_sort=d&_docanchor=&view=c&_searchStrId=968200691&_rerunOrigin=google&_acct=C000024500&_version=1&_urlVersion=0&_userid=499885&md5=effcd49235c10a439f222aac04a16a31
    k_IPTG_out = 0.05;
    
    %LacI_un = LacI_total/(1+(IPTG_in/K50_IPTG)^n_IPTG); % unbound LacI
    
    % GFP conc
    % http://www.sciencedirect.com/science?_ob=ArticleURL&_udi=B6T36-45XTV7
    % V-5&_user=499885&_rdoc=1&_fmt=&_orig=search&_sort=d&_docanchor=&view=c&_searchStrId=968314323&_rerunOrigin=google&_acct=C000024500&_version=1&_urlVersion=0&_userid=499885&md5=e3d4f1c19baff13e51e0e3f02f0be4e1
    % 7000 - 200,000 per cell in salmonella
    