%% TU Delft iGEM 2009 team
%% Plot Regions
%%
%% This file can be used create the red and yellow stability plots but it
%% should be called from the sweepcases.m file unless all the right
%% variables are in the workspace already.
%%
%% parameter values should be changed in the parameters.m file
%%
%% October 6, 2009
%% Version 2.2

regions = zeros(size(delay_time));

[vertical,horizontal] = size(delay_time);

for countvert = 1:vertical
    for counthori = 1:horizontal
        if delay_time(countvert,counthori) < 800 %% not an infinite delay
            regions(countvert,counthori) = 1;
            if delay_time(countvert,counthori) < 10 %% delay less than 10 min
                regions(countvert,counthori) = 2;
            end
        end
    end
end
    
clf;

%% Create axes
axes1 = axes(...
  'YMinorGrid','on',...
  'YMinorTick','on');
  %'YScale','log');
  %'Parent',figure1);
axis(axes1,[parameter1(1) parameter1(length(parameter1)) parameter2(1) parameter2(length(parameter2)) min(min(regions)) max(max(regions))]);
xlabel(axes1,graphxtitle);
ylabel(axes1,graphytitle);
zlabel(axes1,'Delay Time [min]');
grid(axes1,'on');
hold(axes1,'all');
                
plowking = surf(parameter1,parameter2,regions,'Parent',axes1);
colormap autumn
view(0, 90);

saveas(axes1,strcat(variable_to_sweep,'_regions'),'fig')
saveas(axes1,strcat(variable_to_sweep,'_regions'),'png')